EQTY LabDocs

Compute subject CID

Computes the JCS CID of the subject, stores it in the blob store, and returns the CID. The caller needs apply_policies on the project the subject's id names, or in the organization when the id is not a project UUID.

posthttps://<host>/gov/v1/cid/subject
bash
curl --request POST \
  --url 'https://<host>/gov/v1/cid/subject' \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '{"description":"string","extra":"{\"date\":\"02/23/2025\", \"department\": \"R&D\"}","id":"938a76ed-2441-45d9-921b-397ce26c8364","name":"string","organizationDescription":"string","organizationId":"string","organizationName":"string"}'
javascript
const response = await fetch("https://<host>/gov/v1/cid/subject", {
  method: "POST",
  headers: {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
  },
  body: JSON.stringify({
    "description": "string",
    "extra": "{\"date\":\"02/23/2025\", \"department\": \"R&D\"}",
    "id": "938a76ed-2441-45d9-921b-397ce26c8364",
    "name": "string",
    "organizationDescription": "string",
    "organizationId": "string",
    "organizationName": "string"
  })
});

console.log(response.status);
typescript
const response = await fetch("https://<host>/gov/v1/cid/subject", {
  method: "POST",
  headers: {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
  },
  body: JSON.stringify({
    "description": "string",
    "extra": "{\"date\":\"02/23/2025\", \"department\": \"R&D\"}",
    "id": "938a76ed-2441-45d9-921b-397ce26c8364",
    "name": "string",
    "organizationDescription": "string",
    "organizationId": "string",
    "organizationName": "string"
  })
});
if (!response.ok) throw new Error(`${response.status} ${response.statusText}`);

console.log(response.status);
python
import requests

response = requests.post(
    "https://<host>/gov/v1/cid/subject",
    headers={
        "Authorization": "Bearer <token>",
        "Content-Type": "application/json",
    },
    json={
        "description": "string",
        "extra": "{\"date\":\"02/23/2025\", \"department\": \"R&D\"}",
        "id": "938a76ed-2441-45d9-921b-397ce26c8364",
        "name": "string",
        "organizationDescription": "string",
        "organizationId": "string",
        "organizationName": "string",
    },
)
response.raise_for_status()
print(response.status_code)
go
package main

import (
	"fmt"
	"io"
	"net/http"
	"strings"
)

func main() {
	body := strings.NewReader(`{
	  "description": "string",
	  "extra": "{\"date\":\"02/23/2025\", \"department\": \"R&D\"}",
	  "id": "938a76ed-2441-45d9-921b-397ce26c8364",
	  "name": "string",
	  "organizationDescription": "string",
	  "organizationId": "string",
	  "organizationName": "string"
	}`)
	req, err := http.NewRequest(http.MethodPost, "https://<host>/gov/v1/cid/subject", body)
	if err != nil {
		panic(err)
	}
	req.Header.Set("Authorization", "Bearer <token>")
	req.Header.Set("Content-Type", "application/json")

	res, err := http.DefaultClient.Do(req)
	if err != nil {
		panic(err)
	}
	defer res.Body.Close()

	data, err := io.ReadAll(res.Body)
	if err != nil {
		panic(err)
	}
	fmt.Println(res.Status, string(data))
}
java
import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;

public class Example {
    public static void main(String[] args) throws Exception {
        HttpRequest request = HttpRequest.newBuilder()
            .uri(URI.create("https://<host>/gov/v1/cid/subject"))
            .header("Authorization", "Bearer <token>")
            .header("Content-Type", "application/json")
            .method("POST", HttpRequest.BodyPublishers.ofString("""
                {
                  "description": "string",
                  "extra": "{\\"date\\":\\"02/23/2025\\", \\"department\\": \\"R&D\\"}",
                  "id": "938a76ed-2441-45d9-921b-397ce26c8364",
                  "name": "string",
                  "organizationDescription": "string",
                  "organizationId": "string",
                  "organizationName": "string"
                }
                """))
            .build();

        HttpResponse<String> response = HttpClient.newHttpClient()
            .send(request, HttpResponse.BodyHandlers.ofString());
        System.out.println(response.statusCode() + " " + response.body());
    }
}
csharp
using System.Net.Http.Headers;
using System.Text;

using var client = new HttpClient();
using var request = new HttpRequestMessage(HttpMethod.Post, "https://<host>/gov/v1/cid/subject");
request.Headers.Authorization = new AuthenticationHeaderValue("Bearer", "<token>");
request.Content = new StringContent("""
    {
      "description": "string",
      "extra": "{\"date\":\"02/23/2025\", \"department\": \"R&D\"}",
      "id": "938a76ed-2441-45d9-921b-397ce26c8364",
      "name": "string",
      "organizationDescription": "string",
      "organizationId": "string",
      "organizationName": "string"
    }
    """, Encoding.UTF8, "application/json");

using var response = await client.SendAsync(request);
Console.WriteLine($"{(int)response.StatusCode} {await response.Content.ReadAsStringAsync()}");
php
<?php

$ch = curl_init('https://<host>/gov/v1/cid/subject');
curl_setopt_array($ch, [
    CURLOPT_CUSTOMREQUEST => 'POST',
    CURLOPT_HTTPHEADER => [
        'Authorization: Bearer <token>',
        'Content-Type: application/json',
    ],
    CURLOPT_POSTFIELDS => <<<'JSON'
    {
      "description": "string",
      "extra": "{\"date\":\"02/23/2025\", \"department\": \"R&D\"}",
      "id": "938a76ed-2441-45d9-921b-397ce26c8364",
      "name": "string",
      "organizationDescription": "string",
      "organizationId": "string",
      "organizationName": "string"
    }
    JSON,
    CURLOPT_RETURNTRANSFER => true,
]);

$response = curl_exec($ch);
$status = curl_getinfo($ch, CURLINFO_RESPONSE_CODE);
echo $status . " " . $response . PHP_EOL;
ruby
require "net/http"

uri = URI("https://<host>/gov/v1/cid/subject")
request = Net::HTTP::Post.new(uri)
request["Authorization"] = "Bearer <token>"
request["Content-Type"] = "application/json"
request.body = <<~'JSON'
  {
    "description": "string",
    "extra": "{\"date\":\"02/23/2025\", \"department\": \"R&D\"}",
    "id": "938a76ed-2441-45d9-921b-397ce26c8364",
    "name": "string",
    "organizationDescription": "string",
    "organizationId": "string",
    "organizationName": "string"
  }
JSON

response = Net::HTTP.start(uri.hostname, uri.port, use_ssl: uri.scheme == "https") do |http|
  http.request(request)
end
puts "#{response.code} #{response.body}"
rust
// Cargo.toml dependencies: reqwest (features "json"), serde_json, tokio (features "full")
use serde_json::json;

#[tokio::main]
async fn main() -> Result<(), Box<dyn std::error::Error>> {
    let response = reqwest::Client::new()
        .post("https://<host>/gov/v1/cid/subject")
        .header("Authorization", "Bearer <token>")
        .json(&json!({
            "description": "string",
            "extra": "{\"date\":\"02/23/2025\", \"department\": \"R&D\"}",
            "id": "938a76ed-2441-45d9-921b-397ce26c8364",
            "name": "string",
            "organizationDescription": "string",
            "organizationId": "string",
            "organizationName": "string"
        }))
        .send()
        .await?;

    println!("{} {}", response.status(), response.text().await?);
    Ok(())
}

Authorizations

  • BearerAuth · HTTP bearer (JWT)

Request bodyrequired

application/json
  • descriptionstring | null
  • extraobject | null
    Show properties

    Map of any

  • idstringrequired
  • namestring | null
  • organizationDescriptionstring | null
  • organizationIdstring | null
  • organizationNamestring | null
Examplejson
{
  "description": "string",
  "extra": "{\"date\":\"02/23/2025\", \"department\": \"R&D\"}",
  "id": "938a76ed-2441-45d9-921b-397ce26c8364",
  "name": "string",
  "organizationDescription": "string",
  "organizationId": "string",
  "organizationName": "string"
}

Responses

200The JCS CID of the subject

text/plain

string

401Missing or invalid bearer token

application/json
  • callstackobject
    Show properties

    object | null

  • errorstringrequired
Examplejson
{
  "callstack": {},
  "error": "string"
}

403Caller lacks apply_policies on the project named by subject.id (or at the organization when the subject is not a project)

application/json
  • callstackobject
    Show properties

    object | null

  • errorstringrequired
Examplejson
{
  "callstack": {},
  "error": "string"
}

500Internal error

application/json
  • callstackobject
    Show properties

    object | null

  • errorstringrequired
Examplejson
{
  "callstack": {},
  "error": "string"
}

503Auth Service or blob storage unavailable

application/json
  • callstackobject
    Show properties

    object | null

  • errorstringrequired
Examplejson
{
  "callstack": {},
  "error": "string"
}